<template>
  <div class="mb-2">
    <label v-if="field.label">
      {{ field.label }}
      <RequiredIcon v-if="isRequired" />
      <InfoTooltip v-if="field.tooltip" :text="field.tooltip" />
    </label>
    <div class="radion-button-list">
      <div
        :class="['form-check', { 'form-check-inline': field.inline }]"
        v-for="option in field.options"
        :key="option.value"
      >
        <input
          type="radio"
          :id="`${fieldPrefix}${field.name}_${option.value}`"
          class="form-check-input"
          v-model="fieldValue"
          :aria-label="field.label"
          :value="option.value"
          :disabled="field.disabled || busy"
          @input="onInput"
        />
        <label class="form-check-label" :for="`${fieldPrefix}${field.name}_${option.value}`">{{ option.text }}</label>
      </div>
    </div>
    <div class="text-danger" v-if="error">{{ error }}</div>
  </div>
</template>

<script>
import { useVFormControl } from '../../plugins/vform-plugin.js'
import InfoTooltip from '../info-tooltip.vue'
import RequiredIcon from '../required-icon.vue'

export default {
  name: 'VFormRadio',
  props: {
    formName: { type: String, required: true },
    field: { type: Object, required: true },
    fieldPrefix: { type: String, required: true },
    modelState: { type: Object, default: null }, // Taken from the API response if validation fails at the server.
    busy: { type: Boolean, default: false },
  },
  components: {
    InfoTooltip,
    RequiredIcon,
  },
  setup(props, context) {
    return useVFormControl(props, context)
  },
}
</script>
